#include <iostream>
#include <utility>

using namespace std;

pair<int, int> sadulotsing(float** tabel, int m, int n, float vaartus)
{
    int rida = 0;
    int veerg = n-1;

    while (rida < m && veerg > -1) {
        if (abs(vaartus - tabel[rida][veerg]) < 0.01) return make_pair(rida, veerg);
        else if (vaartus > tabel[rida][veerg]) {
            veerg--;
        }
        else {
            rida++;
        }
    }
    return make_pair(-1, -1);
}

int main()
{
    int t, k;
    cin >> t >> k;
    float** tabel = new float*[k+1];

    for (int i = 0; i <= k; i++) {
        tabel[i] = new float[t];
    }

    for (int i = 0; i < k+1; i++) {
        for (int j = 0; j < t; j++)
        {
            cin >> tabel[i][j];
        }
    }

    pair<int, int> p;
    cout.precision(1); //ks koht prast koma
    cout << fixed;
    for (int i = 0; i < 7; i++)
    {
        float f;
        cin >> f;
        p = sadulotsing(tabel, k+1, t, f);
        if (p.first == -1) cout << "POLE";
        else
            cout << tabel[0][p.second];
        if (i < 6) cout << " ";
    }
    cout << endl;
}