import java.util.Scanner;

public class Lipud3 {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        // alustame esimeselt realt, kust kutsutakse
        // rekursiivselt vlja jrgmiste ridade proovimisi
        int res = tryrow(0, n);
        System.out.println(res);
    }

    static int MAXN = 16;

    // peame meeles, millistel veergudel ja diagonaalidel lipud on
    static char[] col = new char[MAXN]; // (i, j) -> j
    static char[] updiag = new char[2 * MAXN]; // (i, j) -> i + j
    static char[] downdiag = new char[2 * MAXN]; // (i, j) -> i - j + N

    static int tryrow(int y, int n) {// y = mitmendale reale proovime lippu panna
        if (y == n) return 1;
        int res = 0;
        for (int x = 0; x < n; x++) { // proovime kiki veerge
            // kontrollime, kas veerg + diagonaalid on vabad
            if (col[x] == 0 && updiag[y + x] == 0 && downdiag[y - x + MAXN] == 0) {
                col[x] = 1; // mrgime veeru kasutatuks
                updiag[y + x] = 1;
                downdiag[y - x + MAXN] = 1;
                res += tryrow(y + 1, n); // liidame kik jrgmiste ridade vimalused
                col[x] = 0; // taastame eelneva seisu
                updiag[y + x] = 0;
                downdiag[y - x + MAXN] = 0;
            }
        }
        return res;
    }
}
