import sys

MAXN = 16
col = [0 for x in range(MAXN)]  # (i, j) -> j
updiag = [0 for x in range(MAXN * 2)]  # (i, j) -> i + j
downdiag = [0 for x in range(MAXN * 2)]  # (i, j) -> i - j + N


def tryrow(y, n):  # y = mitmendale reale proovime lippu panna
    if (y == n):
        return 1
    res = 0
    for x in range(n):  # proovime kõiki veerge
        # kontrollime, kas veerg + diagonaalid on vabad
        if (col[x] == 0 and updiag[y + x] == 0 and downdiag[y - x + MAXN] == 0):
            col[x] = 1  # märgime veeru kasutatuks
            updiag[y + x] = 1
            downdiag[y - x + MAXN] = 1
            res += tryrow(y + 1, n)  # liidame kõik järgmiste ridade võimalused
            col[x] = 0  # taastame eelneva seisu
            updiag[y + x] = 0
            downdiag[y - x + MAXN] = 0


n = int(sys.stdin.readline())
# alustame esimeselt realt, kust kutsutakse
# rekursiivselt välja järgmiste ridade proovimisi
res = tryrow(0, n)
print(res)
