#include <iostream>
using namespace std;

#define MAXN 16
bool row=true;

int tryrow(int y, int lim, int n, int col, int updiag, int downdiag) {
	int res = 0;
	if (y == n)	{
		res ++;
		if (row) res++; // esimese rea esimese poole loeme topelt
		return res;
	}

	int positions = (1 << lim) - 1; // arv, kus lim bitti on hed
	positions &= ~col;      // nullime hivatud veerud
	positions &= ~updiag;   // nullime hivatud diagonaalid
	positions &= ~downdiag; // nullime hivatud diagonaalid

	while (positions > 0) // vabu ruute on niikaua kui mni bitt on mittenull
	{
		int lsb = lsb = -(positions)& positions; // alumine vaba bitt
		if(y == 0)  
			row = (lsb < (1 << n/2)); //Kas oleme esimese rea esimeses pooles 
		int newupdiag = (updiag | lsb) >> 1;     // jrgmise rea ks diagonaal
		int newdowndiag = (downdiag | lsb) << 1; // jrgmise rea teine diagonaal
		int newcol = col | lsb;  // jrgmise rea hivatud veerud
		positions &= ~lsb;       // nullime praeguse ruudu
		res += tryrow(y + 1, n, n, newcol, newupdiag, newdowndiag);
	}

	return res;
}

int main()
{
	int n;
	cin >> n;
	// alustame esimeselt realt, kust kutsutakse 
	// rekursiivselt vlja jrgmiste ridade proovimisi
	// esimese rea limiit on poole rea pikkuseni, algul on veerud ja diagonaalid vabad
	int res = tryrow(0, (n + 1) / 2, n, 0, 0, 0);
	cout << res;
}
