#include <iostream>
#include <utility>

using namespace std;
int hinnad[7] = { 10, 20, 30, 32, 89, 93, 100 };

int rotsing(int vaartus, int algus, int lopp)
{
	if (algus > lopp) return -1; //ei leitud sellist vrtust
	int keskkoht = (algus + lopp) / 2; //leiame jada keskmise elemendi indeksi
	if (vaartus < hinnad[keskkoht]) //kui otsitav vrtus on viksem kui keskmise elemendi vrtus
		return rotsing(vaartus, algus, keskkoht - 1); //otsime jadast eestpoolt
	if (vaartus > hinnad[keskkoht]) //kui otsitav vrtus on suurem kui keskmine elemendi vrtus
		return rotsing(vaartus, keskkoht + 1, lopp); //otsime jadas tagantpoolt
	return keskkoht; //vaartus == hinnad[keskmine] ja tagastame sobiva elemendi indeksi
}

int iotsing(int vaartus, int algus, int lopp)
{
	while (algus <= lopp) {
		int keskkoht = (algus + lopp) / 2;
		if (vaartus == hinnad[keskkoht]) return keskkoht;
		else if (vaartus < hinnad[keskkoht])
			lopp = keskkoht - 1;
		else if (vaartus > hinnad[keskkoht])
			algus = keskkoht + 1;
	}
	return -1;
}

int main()
{
	int a;
	cout <<	iotsing(93, 0, 6);
    cout << rotsing(93, 0, 6);
    cout << iotsing(50, 0, 6);
    cout << rotsing(50, 0, 6);
}