import java.util.Arrays;
import java.util.Scanner;

public class Otsing {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int i;
        int pikkus = scanner.nextInt();
        hinnad = new int[pikkus];
        for (i = 0; i < pikkus; i++) {
            hinnad[i] = scanner.nextInt();
        }
        Arrays.sort(hinnad);
        System.out.println(otsi_rekursiivselt(pikkus / 2, 0, pikkus - 1));
        System.out.println(iotsing(pikkus / 2, 0, pikkus - 1));
    }

    static int[] hinnad;

    static int otsi_rekursiivselt(int vaartus, int algus, int lopp)
    {
        if (algus > lopp) return -1; //ei leitud sellist vrtust
        int keskkoht = (algus + lopp) / 2; //leiame jada keskmise elemendi indeksi
        if (vaartus < hinnad[keskkoht]) { //kui otsitav vrtus on viksem kui keskmise elemendi vrtus
            return otsi_rekursiivselt(vaartus, algus, keskkoht - 1); //otsime jadast eestpoolt
        }
        if (vaartus > hinnad[keskkoht]) { //kui otsitav vrtus on suurem kui keskmine elemendi vrtus
            return otsi_rekursiivselt(vaartus, keskkoht + 1, lopp); //otsime jadas tagantpoolt
        }
        return keskkoht; //vaartus == hinnad[keskmine] ja tagastame sobiva elemendi indeksi
    }

    static int iotsing(int vaartus, int algus, int lopp)
    {
        while (algus <= lopp) {
            int keskkoht = (algus + lopp) / 2;
            if (vaartus == hinnad[keskkoht]) return keskkoht;
            else if (vaartus < hinnad[keskkoht])
                lopp = keskkoht - 1;
            else if (vaartus > hinnad[keskkoht])
                algus = keskkoht + 1;
        }
        return -1;
    }
}
