def mullimeetod(jada, pikkus):
    vahetus = True
    while (vahetus): #kui on olnud vahetusi
        vahetus = False #veel ei ole vahetusi olnud
        for i in range(1, pikkus):
            if (jada[i - 1] > jada[i]): #kui eelnev on suurem järgmisest
                temp = jada[i - 1] #vahetame elemendid
                jada[i - 1] = jada[i]
                jada[i] = temp
                vahetus = True #ja peame meeles, et vahetus toimus



    return 0


def optmullimeetod(jada, pikkus):
    viimane = pikkus
    while (viimane > 0): #kui on olnud vahetusi
        viimane = 0 #veel ei ole vahetusi olnud
        for i in range(1, pikkus):
            if (jada[i - 1] > jada[i]): #kui eelnev on suurem järgmisest
                temp = jada[i - 1] #vahetame elemendid
                jada[i - 1] = jada[i]
                jada[i] = temp
                viimane = i #ja peame meeles viimase vahetuse koha


        pikkus = viimane

    return 0


def valikmeetod(jada, pikkus):
    for j in range(pikkus): #üksik element on vähim, piisab eelviimaseni vaatamisest
        min = j #paneme esimese õige asukohata elemendi minimaalseks
        for i in range(j + 1, pikkus): #käime jada lõpuni läbi
            if (jada[i] < jada[min]): #leidime väiksema elemendi
                min = i #jätame asukoha meelde


        if (min != j): #kui vähim element ei ole juba õigel kohal
            temp = jada[j] #vahetame elemendid
            jada[j] = jada[min]
            jada[min] = temp




def pistemeetod(jada, pikkus):
    for i in range(1, pikkus): #vaatame iga elementi alates teisest
        #kuni vaadeldava elemendini jada[i] on jada sorteeritud. Otsime õige koha jadas
        j = i
        while (j > 0 and jada[j - 1] > jada[j]):
            temp = jada[j] #vahetame elemendid
            jada[j] = jada[j - 1]
            jada[j - 1] = temp
            j -= 1




def poimi(jada, v, keskkoht, p):
    vpikkus = keskkoht - v + 1 # esimese lõigu pikkus
    ppikkus = p - keskkoht # teise lõigu pikkus

    V = [] # põimimiseks teeme vasaku ja
    P = [] # parema lõigu jaoks eraldi massiivid

    for i in range(vpikkus):
        V.append(jada[v + i])
    for j in range(ppikkus):
        P.append(jada[keskkoht + 1 + j])

    i = 0 # vasakpoolse jada esimese elemendi indeks
    j = 0 # parempoolse jada esimese elemendi indeks
    k = v # põimitava koha algusindeks jadas
    while (i < vpikkus and j < ppikkus): # kuni mõlemas jadas on vaatamata elemente
        if (V[i] <= P[j]): # vasakul on mittesuurem paigutamata element
            jada[k] = V[i] # paneme selle jadasse
            k += 1
            i += 1

    else: # paremal on väiksem element
        jada[k] = P[j] # paigutame selle jadasse
        k += 1
        i += 1



    while (i < vpikkus):#kui vasakus jadas on veel elemente
        jada[k] = V[i] #kopeerime need järjest jadasse
        k += 1
        i += 1


    while (j < ppikkus): # kui paremas jadas on veel elemente
        jada[k] = P[j] # kopeerime need järjest jadasse
        k += 1
        i += 1



def poimemeetod(jada, v, p):
    if (v < p):
        keskkoht = (v + p) / 2
        poimemeetod(jada, v, keskkoht)
        poimemeetod(jada, keskkoht + 1, p)
        poimi(jada, v, keskkoht, p)



def jaota(jada, v, p):
    e = jada[v]
    i = v - 1
    j = p + 1
    while (True):
        i += 1
        while (jada[i] < e):
            i += 1
        j -= 1
        while (jada[j] > e):
            j -= 1
        if (i >= j):
            return j
        print(str(i) + " " + str(j))
        temp = jada[i]
        jada[i] = jada[j]
        jada[j] = temp



def kiirmeetod(jada, v, p):
    if (v < p):
        e = jaota(jada, v, p)
        print()
        kiirmeetod(jada, v, e)
        kiirmeetod(jada, e + 1, p)




jada = [2, 4, 5, 4, 1]
#optmullimeetod(jada, 5)
#valikmeetod(jada, 5)
#pistemeetod(jada, 5)
#poimemeetod(jada, 0, 4)
kiirmeetod(jada, 0, 4)
s = ""
for i in range(5):
    s = s + str(jada[i]) + " "
print(s)
