import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class Hammasrattad {

    public static void main(String[] args) throws Exception {
        Scanner sis = new Scanner(System.in);

        int n = sis.nextInt();
        int m = sis.nextInt();

        Set<Integer> s = new HashSet<>();
        for (int a = n; a <= m; a++) {
            for (int b = n; b <= m; b++) {
                int d = gcd(a, b);
                s.add(a / d);
                s.add(b / d);
            }
        }

        System.out.println(s.size());
    }
    static int gcd(int a, int b) {
        while (b > 0) {
            int c = b;
            b = a % b;
            a = c;
        }
        return a;
    }
}
