#include <iostream>

using namespace std;

int* LeiaPikimKasvav(int N, int* S){
    int* pikkused = new int[N];
    int* indeksid = new int[N];

    for (int i = 0; i < N; i++){
        pikkused[i] = 1;
        indeksid[i] = i;
    }

    int pikim = 0;
    int pikimaIndeks = 0;
    for (int i = 0; i < N; i++){
        if (pikkused[i] > pikim){
            pikim = pikkused[i];
            pikimaIndeks = i;
        }
        for (int j = i + 1; j < N; j++){
            if (S[j] > S[i] && pikkused[i] + 1 > pikkused[j]){
                 pikkused[j] = pikkused[i] + 1;
                 indeksid[j] = i;
            }
        }
    }
    
    int* alamjada = new int[pikim];
        for (int i = pikim; i > 0; --i){
            alamjada[i-1] = S[pikimaIndeks];
            pikimaIndeks = indeksid[pikimaIndeks];
        }

    return alamjada;
}

int main()
{
    int N;
    cin >> N; //jada pikkus
    int* jada = new int[N];
    for (int i = 0; i < N; i++){
        cin >> jada[i]; //jada elemendid
    }

    int* vastus = LeiaPikimKasvav(N, jada);
    for (int i = 0; i < sizeof(vastus); i++) {
        cout << vastus[i] << endl;
    }
    return 0;
}