#include <iostream>
#include <algorithm>

using namespace std;

const int MaxInt = 32767;
int N;
int* V;

int leiaKogus(int S)
{
    int* kogused = new int[S + 1];
    kogused[0] = 0;
    for (int i = 1; i <= S; i++) {
        //vrtusteks alguses lpmatused, kui selle koguseni ei juta, siis jb see
        //vrtus - sisuliselt thendab see, et sellel kohal asuvat summat ei saa antud
        //mntidest moodustada
        kogused[i] = MaxInt;
    }

    for (int i = 1; i <= S; i++) {
        for (int j = 0; j < N; j++) {
            if (V[j] <= i) { //jtab vahele mndid, mille vrtus on suurem kui summa
                kogused[i] = min(kogused[i - V[j]] + 1, kogused[i]);
            }
        }
    }
    return kogused[S];
}


int main()
{
    int S;
    cin >> S; //Summa
    cin >> N; //Mntide arv
    V = new int[N];
    for (int i = 0; i < N; i++){
        cin >> V[i]; //Mntide vrtused
    }
    cout << leiaKogus(S) << endl;
    return 0;
}