#include <iostream>

using namespace std;

const int MaxInt = 32767;
int N;
int* V;

int leiaKogus(int S)
{
    int* kogused = new int[S + 1];
    int* viimased = new int[S + 1]; //viimasena lisatud mndi vrtus iga summa jaoks
    kogused[0] = 0;
    viimased[0] = 0;
    for (int i = 1; i <= S; i++) {
        kogused[i] = MaxInt;
        viimased[i] = 0;
    }
    for (int i = 1; i <= S; i++) {
        for (int j = 0; j < N; j++) {
            if (V[j] <= i && kogused[i - V[j]] + 1 < kogused[i]){
                kogused[i] = kogused[i - V[j]] + 1;
                viimased[i] = V[j];
            }
        }
    }
    int k = S;
    while (k > 0) {
        cout << viimased[k] << endl;
        k -= viimased[k];
    }
    return S;
}

int main()
{
    int S;
    cin >> S; //Summa
    cin >> N; //Mntide arv
    V = new int[N];
    for (int i = 0; i < N; i++){
        cin >> V[i]; //Mntide vrtused
    }
    leiaKogus(S);
    return 0;
}