import java.util.Scanner;

public class Vennad {

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int N = in.nextInt(); //kinkide arv
        int[] pakid = new int[4];
        for (int i = 0; i < N; i++) {
            pakid[i] = in.nextInt(); //kinkide vrtused
        }

        System.out.println(LeiaVahe(N, pakid));
    }

    static int LeiaVahe(int mituPakki, int[] pakid) {
        int suurimVahe = 0;
        for (int i = 0; i < mituPakki; i++) {
            suurimVahe += pakid[i]; //Leiame suurima vimaliku vahe
        }
        int[][] tabel = new int[suurimVahe + 1][2];
        tabel[0][1] = 1; //kui midagi jagada pole, on vahe 0
        for (int i = 1; i <= suurimVahe; i++) {
            tabel[i][1] = 0; //lejnud vahed on vimatud
        }
        for (int i = 0; i < mituPakki; i++) {
            int praeguneRida = i % 2;
            int eelmineRida = (i + 1) % 2;
            for (int j = 0; j < suurimVahe; j++) {
                int eelmineVahe = j - pakid[i];
                if (eelmineVahe < 0) {
                    eelmineVahe = -eelmineVahe;
                }
                if (tabel[eelmineVahe][eelmineRida] == 1) {
                    tabel[j][praeguneRida] = 1;
                    continue;
                }
                eelmineVahe = j + pakid[i];
                if (eelmineVahe > suurimVahe || tabel[eelmineVahe][eelmineRida] == 0) {
                    tabel[j][praeguneRida] = 0;
                    continue;
                }
                tabel[j][praeguneRida] = 1;
            }
        }
        int vastus = 0;
        for (int i = 0; i < suurimVahe; i++) {
            int praeguneRida = (mituPakki - 1) % 2;
            if (tabel[i][praeguneRida] == 1) {
                vastus = i; //leiame esimese vimaliku vahe, see ongi vastuseks
                break;
            }
        }
        return vastus;
    }

}