#include "iostream"

using namespace std;

int tabel[100][100];

int loenda(int n, int ristsumma, int jark)
{
    if (n == 0) return 0;
    int esimene = n / pow(10, jark);
    if (ristsumma < esimene)
        return 0;
    int aste = rint(pow(10, jark));
    int vastus = loenda(n % aste, ristsumma - esimene, jark - 1);
    for (int i = 0; i < esimene; i++){
        vastus += tabel[jark][ristsumma - i];
    }
    return vastus;
}

int main()
{
    tabel[0][0] = 1;
    for (int i = 0; i < 9; i++) {
        for (int j = 0; j < 90; j++) {
            for (int k = 0; k < 10; k++) {
                tabel[i + 1][j + k] += tabel[i][j];
            }
        }
    }

    int n;
    cin >> n;

    int a = n;
    int jark = 0;
    int summa = 0;
    while (a > 0) {
        summa += a % 10;
        a = a / 10;
        jark++;
    }

    cout << loenda(n, summa, jark) << endl;
    return 0;
}
