import java.io.IOException;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

class Loomad {

    public static int [][] edges;
    public static int [] edgesCount;
    public static boolean [] visited;

    public static int [] ints;
    public static int intsCount;

    public static void topologicalSort (int id) {
        if (!visited[id]) {
            visited[id]=true;
            for (int i=0;i<edgesCount[id];i++) {
                topologicalSort(edges[id][i]);
            }
            ints[intsCount++]=id;
        }
    }

    public static void main(String[] args) throws IOException {
        Scanner scanner = new Scanner(System.in);

        int n=scanner.nextInt();

        edges=new int [1001][1001];
        edgesCount=new int [1001];
        int m = 0;
        Map<String, Integer> map = new TreeMap<>();
        Map<Integer, String> map1 = new TreeMap<>();
        scanner.nextLine();
        for (int i=0;i<n;i++) {
            String[] split = scanner.nextLine().split(" ");
            if (!map.containsKey(split[0])) {
                m++;
                map.put(split[0], m);
                map1.put(m, split[0]);
            }
            if (!map.containsKey(split[1])) {
                m++;
                map.put(split[1], m);
                map1.put(m, split[1]);
            }
            edges[map.get(split[0])][edgesCount[map.get(split[0])]++]=map.get(split[1]);
        }

        visited=new boolean [m+1];
        ints=new int [m];
        intsCount=0;
        for (int i=1;i<=m;i++) {
            topologicalSort(i);
        }

        for (int i=intsCount-1;i>=0;i--) {
            System.out.print(map1.get(ints[i]));
            if (i==0) {
                System.out.println();
            } else {
                System.out.print(" ");
            }
        }
    }

}