import sys
from collections import namedtuple
from collections import deque

Loom  = namedtuple('Loom', ['Nimi', 'Sisse', 'Valja'])
graaf = {}

def leia_loom(nimi):
    global graaf
    if (not nimi in graaf): # kui selle nimega looma veel ei ole
        graaf[nimi] = Loom(nimi, {}, {})
    return graaf[nimi]

servi = int(sys.stdin.readline())
for i in range(servi):
    sisend = sys.stdin.readline().split()
    esimene = leia_loom(sisend[0])
    teine = leia_loom(sisend[1])
    esimene.Valja[teine.Nimi] = teine
    teine.Sisse[esimene.Nimi] = esimene

valjund = []
jrkd = deque([])

# kõigepealt leiame kõik tipud, millel sissetulevaid kaari ei ole. Need loomad
# saavad olla kõige tugevamad teadaoleva info põhjal.
for m in graaf:
    if (not graaf[m].Sisse):  
        jrkd.append(graaf[m])

while (jrkd): # kuni on veel töötlemata tippe
    n = jrkd.popleft()
    valjund.append(n.Nimi) # lisame vastusesse
        
    for k in n.Valja:
        jrgm = n.Valja[k]
        #eemaldame naabrilt kõik vaadeldavast tipust sissetulevad kaared
        del jrgm.Sisse[n.Nimi] 
        if (not jrgm.Sisse): # kui naabril rohkem sissetulevaid kaari pole
            jrkd.append(jrgm) # lisame selle järjekorda
    n.Valja.clear() # eemaldame tipu kõik väljuvad kaared
 
for m in graaf:
    if (not graaf[m].Sisse):
        continue
    print("EI SAA")
    sys.exit(0)

print(' '.join(valjund))
