import java.util.*;

public class Ratsu2 {

    static int MAX_DIM = 100;
    static int dim, ruutude_arv;

    // massiiv, mis on abiks arvutamisel, kuhu ratsu kia saab (st naabertippude leidmiseks graafis)
    static int[][] deltad =
    {{-2, -1}, {-2, 1}, {2, -1}, {2, 1}, {1, 2}, {1, -2}, {-1, 2}, {-1, -2}};
    static boolean[][] kaidud = new boolean[MAX_DIM][MAX_DIM];

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        dim = scanner.nextInt();
        String salgus, slopp;
        String split[];
        scanner.nextLine();
        split = scanner.nextLine().split(" ");
        salgus = split[0];
        slopp = split[1];
        int[] algus = {salgus.charAt(0) - 'a', salgus.charAt(1) - '1'};
        int[] lopp = {slopp.charAt(0) - 'a', slopp.charAt(1) - '1'};
        otsi(algus, lopp);
    }

    static void otsi(int[] algus, int[] lopp)
    {
        Queue jarjekord = new LinkedList<int[]>();
        // Siin hoiame iga ruudu jaoks meeles lhima tee, kuidas sinna algusest sai.
        Map teed = new TreeMap<int[], String>();

        jarjekord.add(algus);
        kaidud[algus[0]][algus[1]] = true;
        teed.put(algus, "" + (char)(algus[0] + 'a') + (char)(algus[1] + '1'));

        while (!jarjekord.isEmpty()) {
            int[] ruut = ((int[])jarjekord.remove()).clone();
            if (lopp == ruut) { // oleme judnud sihtkohta
                System.out.println(teed.get(ruut)); // vljastame tee
                return; // rohkem otsida pole vaja
            }

            for (int k = 0; k < 8; k++) { // iga vimaliku kigu jaoks
                int x = ruut[0] + deltad[k][0];
                int y = ruut[1] + deltad[k][1];
                if ((x >= 0) && (x < dim) && (y >= 0) && (y < dim) && //mngulaual
                        !kaidud[x][y]) { // ja kimata
                    int[] mp = {x, y};
                    jarjekord.add(mp);
                    kaidud[x][y] = true;
                    // Laiuti lbimise puhul kohe kui uuele ruudule juame, on see lhim
                    // vimalik tee servade arvu mttes. Jtame selle tee meelde
                    teed.put(mp, teed.get(ruut) + " " + (char)(x + 'a') + (char)(y + '1'));
                }
            }
        }
        System.out.println("EI SAA"); // ei ole teed leidnud
    }

}
