import java.util.Scanner;

public class Ratsu3 {

    static int MAX_DIM = 100;
    static int dim, ruutude_arv;

    static int[][] deltad =
            {{-2, -1}, {-2, 1}, {2, -1}, {2, 1}, {1, 2}, {1, -2}, {-1, 2}, {-1, -2}};
    static boolean[][] kaidud = new boolean[MAX_DIM][MAX_DIM];

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int etturid, ratsud=0;
        dim = scanner.nextInt();
        etturid = scanner.nextInt();
        scanner.nextLine();
        String[] split = scanner.nextLine().split(" ");
        for (int i = 0; i < etturid; i++) {
            String ettur = split[i];
            kaidud[ettur.charAt(0) - 'a'][ettur.charAt(1) - '1'] = true;
        }

        for (int i = 0; i < dim; i++)
            for (int j = 0; j < dim; j++) {
                if (!kaidud[i][j]){
                    ratsud++;
                    otsi(i, j);
                }
            }
        System.out.println(ratsud);
    }

    static void otsi(int x, int y)
    {
        kaidud[x][y] = true;

        for (int k = 0; k < 8; k++) {
            int naaber_x = x + deltad[k][0];
            int naaber_y = y + deltad[k][1];
            if ((naaber_x >= 0) && (naaber_x < dim) && // mngulaual
                    (naaber_y >= 0) && (naaber_y < dim) &&
                    !kaidud[naaber_x][naaber_y]) { // ja kimata
                otsi(naaber_x, naaber_y);
            }
        }
    }

}
