import java.util.ArrayList;
import java.util.Scanner;

public class SGL {

    public static void main(String[] args) {
        loegraaf();
        otsi(0);

        //nullime kidud massiivi, et saaksime graafi uuesti lbida
        for (int i = 0; i < tippude_arv; i++)
            kaidud[i] = false;

        if (on_tsykkel(0, -1))
            System.out.println("Tskkel leitud.");
        else
            System.out.println("Tskkel puudub.");
    }

    static int MAX_TIPPE = 1000;
    static ArrayList<Integer>[] graaf = new ArrayList[MAX_TIPPE];
    static boolean[] kaidud = new boolean[MAX_TIPPE]; // alguses kik tipud on kimata
    static int tippude_arv;

    static void loegraaf() {
        Scanner scanner = new Scanner(System.in);
        tippude_arv = scanner.nextInt();
        scanner.nextLine();
        int i, j;
        for (i = 0; i < MAX_TIPPE; i++) {
            graaf[i] = new ArrayList<Integer>();
        }
        for (i = 0; i < tippude_arv; i++) {
            j = 1;
            String[] s = scanner.nextLine().split(" ");
            int tipp = Integer.parseInt(s[0]);
            while (j < s.length){
                int naaber = Integer.parseInt(s[j]);
                graaf[tipp - 1].add(naaber - 1);
            }
        }
    }

    static void tootle(int tipp)
    {
        System.out.print(tipp + " ");
    }

    static void otsi(int tipp)
    {
        kaidud[tipp] = true; // siin me oleme
        tootle(tipp); // teeme midagi selle tipuga
        for (int i = 0; i < graaf[tipp].size(); i++) {
            int naaber = graaf[tipp].get(i); // iga naabertipuga
            if (!kaidud[naaber]) // kus ei ole veel kinud
                otsi(naaber); // kordame sama protseduuri
        }
    }

    static boolean on_tsykkel(int tipp, int eelmine)
    {
        kaidud[tipp] = true;
        for (int i = 0; i < graaf[tipp].size(); i++) {
            int naaber = graaf[tipp].get(i);
            if (!kaidud[naaber]) {
                if (on_tsykkel(naaber, tipp))
                    return true;
            }
            else if (naaber != eelmine)
                return true;
        }
        return false;
    }

}
