import sys
import math
import heapq

sisend = sys.stdin.readline().split()
n = int(sisend[0])
m = int(sisend[1])
a = int(sisend[2]) - 1
b = int(sisend[3]) - 1

Vaadatud = [False]*n # Siin hoiame infot, kas tipp on juba töödeldud
Min_kaugused = [math.inf]*n # Siin hoiame vähimat leitud kaugust algtipust tippu i.
Naabrid = [[] for i in range(n)]
for i in range(m): # Koostame graafi
    sisend = sys.stdin.readline().split()
    x = int(sisend[0]) - 1
    y = int(sisend[1]) - 1
    t = int(sisend[2])    
    Naabrid[x].append((t, y))
    Naabrid[y].append((t, x))

def leia_teepikkus(start, siht, n):
    global Vaadatud, Min_kaugused, Naabrid
    kaugused = []
    #Lähtekoha kaugus iseendast on 0
    Min_kaugused[start] = 0
    heapq.heappush(kaugused, (Min_kaugused[start], start))
    while (kaugused):
        lahim_tipp = heapq.heappop(kaugused)
        tipp = lahim_tipp[1]
        vahim_kaugus = lahim_tipp[0]
        if(tipp == siht): # otsitud tee on leitud
            return vahim_kaugus # tagastame tee pikkuse
        if (Vaadatud[tipp]): # tipp vaadatud, võtame järgmise
            continue
        Vaadatud[tipp] = True # Siin me oleme
        for naaber in Naabrid[tipp]: # Iga naabri jaoks
            if (not Vaadatud[naaber[1]] and # kui naaber on veel käimata 
                naaber[0] + vahim_kaugus < Min_kaugused[naaber[1]]): 
                Min_kaugused[naaber[1]] = naaber[0] + vahim_kaugus
                heapq.heappush(kaugused,(Min_kaugused[naaber[1]],naaber[1]))
    return -1 #ei leidnud teed

print(leia_teepikkus(a, b, n))
