#include <iostream>
#include <string>
#include <algorithm>
using namespace std;

int deltad[8][2] = 
    {{1, 0}, {1, 1}, {0, 1}, {-1, 1}, {-1, 0}, {-1, -1}, {0, -1}, {1, -1}};
int ridu, veerge;
char** kaart;

int taida(int r, int v, char v1, char v2) {
    if (r < 0 || r >= ridu || v < 0 || v >= veerge)  // Kui on vljaspool kaarti
        return 0;
    if (kaart[r][v] != v1) return 0; // kui ei ole esimest vrvi
    int vastus = 1; // lisab vastusele he
    kaart[r][v] = v2; // vrvime teist vrvi, et ei lheks tsklisse
    for (int d = 0; d < 8; d++) {
        vastus += taida(r + deltad[d][0], v + deltad[d][1], v1, v2);
    }
    return vastus;
}

int main()
{
    cin >> ridu >> veerge;
    kaart = new char*[ridu];
    for (int i = 0; i < ridu; i++) {
        kaart[i] = new char[veerge];
        for (int j = 0; j < veerge; j++) {
            cin >> kaart[i][j];
        }
    }

    int veekogusid = 0;
    int suurim = 0;

    for (int i = 0; i < ridu; i++) {
        for (int j = 0; j < veerge; j++) {
            if (kaart[i][j] == 'S') {
                veekogusid++;
                suurim = max(suurim, taida(i, j, 'S', '*'));
            }
        }
    }
    cout << veekogusid << endl;
    cout << suurim << endl;
    return 0;
}
