import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Scanner;

public class Majakavahid {

    static int[] kuud = { 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 };

    static int leiaPaevaNr(String kuupaev) {
        int k = kuupaev.indexOf('.');
        int kuu, paev;
        paev = Integer.parseInt(kuupaev.substring(0, k));
        kuu = Integer.parseInt(kuupaev.substring(k + 1, kuupaev.length()));
        return kuud[kuu-1] + paev;
    }


    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int M = scanner.nextInt();
        int vahetusi = 0;
        ArrayList<int[]> vahetused = new ArrayList<>();
        while (M > 0){
            int N, V;
            N = scanner.nextInt();
            V = scanner.nextInt();
            scanner.nextLine();
            while (V > 0){
                String[] split = scanner.nextLine().split(" ");
                int[] pair = {leiaPaevaNr(split[0]), leiaPaevaNr(split[1])};
                vahetused.add(pair);
                V--;
            }
            M--;
        }

        Collections.sort(vahetused, new Comparator<int[]>() {
            public int compare(int[] a, int[] b) {
                return Integer.valueOf(a[1]).compareTo(b[1]);
            }
        }); // sorteerime alguse jrgi kasvavalt
        int esimenePaev = 1, viimanePaev = 0, vahetusiKokku = 0;
        int i = 0;

        while (viimanePaev < 365) { // Vahetused on leitud
            // ei ole judnud aasta lppu, aga rohkem vahetusi pole vi
            // jrgmise vaatamata vahetuse esimene pev on liiga kaugel
            if (i == vahetused.size() || vahetused.get(i)[0] > esimenePaev) {
                System.out.println("EI SAA");
                return;
            }
            for (; i < vahetused.size() && vahetused.get(i)[0] <= esimenePaev; i++) {
                if (vahetused.get(i)[1] > viimanePaev) { // parem viimane pev
                    viimanePaev = vahetused.get(i)[1];
                }
            }
            vahetusiKokku++; // oleme leidnud parima lpp-peva
            esimenePaev = viimanePaev + 1;
        }

        System.out.println(vahetusiKokku);
    }
}
