import java.util.Scanner;

public class Suveniirid {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int k = scanner.nextInt();
        int l = scanner.nextInt();
        int[] p = new int[n];
        for (int i = 0; i < n; i++) {
            p[i] = scanner.nextInt();
        }
        System.out.println(delivery(n, k, l, p));
    }

    static long delivery(int n, int k, int l, int p[])
    {
        long[] ppAeg = new long[n]; // meeskonnani paki viimise aeg ainult pripeva liikudes
        long[] vpAeg = new long[n]; // meeskonnani paki viimise aeg ainult vastupeva liikudes
        // leiame ajad iga meeskonnani ainult pripeva ja ainult vastupeva liikudes,
        //arvestades, et eelnevad meeskonnad on suveniirid ktte saanud.
        for (int i = 0; i < n; i++) {
            if (i < k) { // esimesed k meeskonda mlemast otsast
                ppAeg[i] = p[i] * 2; // kime pripeva i.nda meeskonnani ja tagasi
                vpAeg[n-1-i] = (l - p[n-1-i]) * 2; // sama vastupeva
            }
            else {
                int j = i-k; // meeskonna indeks, mis jb kindlasti eelmisesse jaotusesse
                ppAeg[i] = p[i] * 2 + ppAeg[j];// eelmised jaotused + praeguse meeskonnani
                vpAeg[n-1-i] = (l - p[n-1-i]) * 2 + vpAeg[n-1-j]; //sama vastupeva
            }
        }
        long vastus = (long)1e18; // vastuseks suur arv, otsime miinimumi

        if (n == k) { // suveniirid saab korraga kaasa vtta ja he ringiga jaotada.
            vastus = l; // sel moel on heks vimalikuks vastuseks sektorite arv.
        }

        // parim saab olla variant, kus jaotame kik vastupeva
        vastus = Math.min(vastus, vpAeg[0]);
        // vi ks tisring ja kik lejnud vastupeva
        vastus = Math.min(vastus, vpAeg[k] + l);
        for (int i = 0; i < n; i++) {
            if (i == n - 1) {
                vastus = Math.min(vastus, ppAeg[i]); // Kik meeskonnad pripeva jaotades
                continue;
            }
            // ainult edasi-tagasi: i. meeskonnani pripeva ja i+1. alates vastupeva.
            vastus = Math.min(vastus, ppAeg[i] + vpAeg[i + 1]);
            if (i + k + 1 == n) { // kui on ainult k meeskonda lpuni
                vastus = Math.min(vastus, ppAeg[i] + l); // ks tisring + lejnud pripeva
            }
            else if (i + k + 1 < n) {
                // pripeva i.nda meeskonnani, siis tisring (k pakki/meeskonda) ja siis
                // edasi alates meeskonnast i+k+1 vastupeva.
                vastus = Math.min(vastus, ppAeg[i] + vpAeg[i + k + 1] + l);
            }
        }
        return vastus;
    }

}
