#include <algorithm>
#include <iostream>
#include <string>

using namespace std;

int NeedlemanWunsch(int n, int m, string s, string t)
{
    int** dp = new int*[n+1];
    for (int i = 0; i <= n; i++) {
        dp[i] = new int[m+1];
        for (int j = 0; j <= m; j++) {
            dp[i][j] = 0;
        }
    }

    int vas = 0;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            int sc = -1;
            if (s[i-1] == t[j-1]) {
                sc = 1;
            }
            dp[i][j] = max(max(dp[i-1][j] - 1, dp[i][j-1] - 1), dp[i-1][j-1] + sc);
        }
    }
    return dp[n][m];
}

int main()
{
    int a, b;
    string A, B;
    cin >> a;
    cin >> A;
    cin >> b;
    cin >> B;
    cout << NeedlemanWunsch(a, b, A, B) << endl;
    return 0;
}
