#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS 1
#endif
#include <algorithm>
#include <utility>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cassert>

#define ll long long

using namespace std;

int maximum_deevs(std::vector<int> y)
{
    int n = y.size();
    //int* hb = new int[n];
    vector<pair<int, int> >* nl = new vector<pair<int, int> >[n];
    for (int i = 0; i < n; i++) {
        vector<pair<int, int> > vi;
        nl[i] = vi;
        //hb[i] = 0;
    }
    int** dp = new int*[n];
    for (int i = 0; i < n; i++)
    {
        dp[i] = new int[n];
        double bs = -3; // (sisuliselt -pi)
        int ch = y[i]; // vaadeldava tipu krgus
        for (int j = i + 1; j < n; j++) {
            int nh = y[j]; // jrgmine tipp
            int cy = nh - ch; // krguste vahe
            int cx = j - i; // kauguste vahe
            double cs = atan2(cy, cx); // tippude vaheliste sirgete nurk radiaanides (-pi kuni pi)
            if (cs >= bs) { // nurk on suurem, kui seni leitud -
                bs = cs;
                int nljs = nl[j].size();
                if (nljs > 0 && nl[j][nljs - 1].second == i - 1) {
                    nl[j][nljs - 1].second = i;
                    continue;
                }
                nl[j].push_back(make_pair(i, i)); // i, i ?
            }
        }
    }

    for (int i = 0; i < n; i++) { // esimesest tipust viimaseni
        for (int j = i; j >= 0; j--) { // vaatame eelmisi tippe
            if (i == j) {
                dp[j][i] = 1; // hetipulisele ligule saab panna 1 deemoni
                continue;
            }
            dp[j][i] = dp[j][i - 1]; //saame panna ligule j..i vhemalt sama palju deemone, kui ligule j..i-1
            int ov = 1;
            int si = j;
            for (int k = 0; k < nl[i].size(); k++) {
                if (nl[i][k].first < si) { // kui algus on enne vaadeldavat indeksit, siis see ei huvita
                    continue;
                }
                if (k == 0 || nl[i][k - 1].second < si) { // kui on esimene lik vi eelmise ligu lpp on enne vaadeldavat ippu
                    if (nl[i][k].first <= si && nl[i][k].second >= si) { // kui oleme ligu sees, siis ei muutu midagi
                        continue;
                    }
                    ov += dp[si][nl[i][k].first - 1]; // liidame need ligud juurde, mis tuleb arvesse vtta
                    continue;
                }
                if (nl[i][k].first - 1 == nl[i][k - 1].second) { //kui kesoleva ligu esimene on sama, mis eelmise ligu viimane
                    continue;
                }
                ov += dp[nl[i][k - 1].second + 1][nl[i][k].first - 1];
            }
            dp[j][i] = max(dp[j][i], ov);
        }
    }
    int vas = dp[0][n - 1];
    return vas;
}

int main() {
    int n;
    assert(1 == scanf("%d", &n));
    std::vector<int> y(n);
    for (int i = 0; i < n; i++) {
        assert(1 == scanf("%d", &y[i]));
    }
    int result = maximum_deevs(y);
    printf("%d\n", result);
    return 0;
}
