import math
import sys

pat = []
lps = []
m = 0
n = 0
str = []


class Segment:
    epsilon = 0.000001

    def __init__(self, l, x2, y2, x1, y1):
        self._l = l
        self.a1 = 180 * math.atan2(x1, y1) / pi
        self.a2 = 180 * math.atan2(x2, y2) / pi
        self.a = self.a2 - self.a1

        if self.a > 180: self.a -= 360
        if self.a < -180: self.a += 360

    def equals(self, s2):
        return math.fabs(self._l - s2._l) < self.epsilon and math.fabs(self.a - s2.A) < self.epsilon


def match():
    i = 0
    j = 0
    lps = []
    le = Segment(0, 0, 0, 0, 0)
    el = Segment(0, 0, 0, 0, 0)

    for a in range(n):
        if le._l < str[a]._l:
            le = str[a]
            i = a
        if el._l < pat[a]._l:
            el = pat[a]
            j = a

    for a in range(n):
        if not str[(i + a) % n].equals(pat[(j + a) % n]):
            return -1
    vas = i - j + 1
    if vas <= 0:
        vas += n

    return vas


pi = 4 * math.atan(1)

n = int(sys.stdin.readline())
m = n

row1 = sys.stdin.readline().split()
row2 = sys.stdin.readline().split()

ox = []
oy = []

ox2 = []
oy2 = []

x1 = []
x2 = []

y1 = []
y2 = []

l1 = []
l2 = []

perim1 = 0.0
perim2 = 0.0
for i in range(n + 1):
    if i < n:
        x1.append(float(row1[i * 2]))
        y1.append(float(row1[i * 2 + 1]))
        ox.append(x1[i])
        oy.append(y1[i])
        x2.append(float(row2[i * 2]))
        y2.append(float(row2[i * 2 + 1]))
        ox2.append(x2[i])
        oy2.append(y2[i])
    if i > 0:
        x1[i % n] -= ox[i - 1]
        y1[i % n] -= oy[i - 1]
        l1.append(math.hypot(x1[i % n], y1[i % n]))
        perim1 += l1[i - 1]
        x2[i % n] -= ox2[i - 1]
        y2[i % n] -= oy2[i - 1]
        l2.append(math.hypot(x2[i % n], y2[i % n]))
        perim2 += l2[i - 1]

rat = perim1 / perim2

for i in range(n):
    pat.append(Segment(l1[i], x1[(i + 1) % n], y1[(i + 1) % n], x1[i], y1[i]))
    str.append(Segment(l2[i] * rat, x2[(i + 1) % n], y2[(i + 1) % n], x2[i], y2[i]))
res = -1

for i in range(2):
    for j in range(2):
        res = match()
        if res > -1: break
        for k in range(n):
            pat[k].A = -pat[k].A
    if res > -1:
        if i == 1: res = n + 1 - res
        break
    for k in range(int(n / 2)):
        vah = pat[k]
        pat[k] = pat[n - 1 - k]
        pat[n - 1 - k] = vah
if res == -1:
    print(-1)
else:
    print(rat)
    print(res)
