import java.util.Scanner;

public class Ilm {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int t, k;
        t = scanner.nextInt();
        k = scanner.nextInt();
        float[][] tabel = new float[k+1][t];

        for (int i = 0; i < k+1; i++) {
            for (int j = 0; j < t; j++) {
                tabel[i][j] = scanner.nextFloat();
            }
        }
        int[] p = new int[2];
        for (int i = 0; i < 7; i++)
        {
            float f;
            f = scanner.nextFloat();
            p = sadulotsing(tabel, k+1, t, f);
            if (p[0] == -1) System.out.print("POLE");
            else {
                System.out.printf("%.2f", tabel[0][p[1]]);
            }
            if (i < 6) System.out.print(" ");
        }
        System.out.println();
    }

    static int[] sadulotsing(float[][] tabel, int m, int n, float vaartus)
    {
        int rida = 0;
        int veerg = n-1;
        int[] ret = new int[2];
        while (rida < m && veerg > -1) {
            if (Math.abs(vaartus - tabel[rida][veerg]) < 0.01) {
                ret[0] = rida;
                ret[1] = veerg;
                return ret;
            }
            else if (vaartus > tabel[rida][veerg]) {
                veerg--;
            }
            else {
                rida++;
            }
        }
        ret[0] = -1;
        ret[1] = -1;
        return ret;
    }
}
