#include <iostream>
#include <fstream>
#include <iomanip>
#include <stdlib.h>
#define _USE_MATH_DEFINES
#include <math.h>

using namespace std;

long double* liidetavad;

long double liida(int start, int end)
{
    if (end == start) //ainult ks arv
        return liidetavad[start]; //tagastame selle
    int keskkoht = (start + end) / 2; //muidu jagame lesande pooleks
        //ja tagastame poolte summa summa
        return (liida(start, keskkoht) + liida(keskkoht + 1, end));
}

long double liidaKiirem(int start, int end)
{
    if (end - start < 1000) { //liita pole rohkem kui 1000 arvu, liidame tavaliselt
        long double vas = 0;
        for (int i = start; i <= end; i++){
            vas += liidetavad[i];
        }
        return vas;
    }
    //liita on rohkem arve, jagame lesande pooleks
    int keskkoht = (start + end) / 2;
        return (liidaKiirem(start, keskkoht) + liidaKiirem(keskkoht + 1, end));
}


int main()
{
	int n;
	cin >> n;
	liidetavad = new long double[n];
	for (int i = 0; i < n; i++) {
		cin >> liidetavad[i];
	}
	cout << "start" << endl;
	cout << scientific;
	long double vastus1 = 0, vastus2 = 0, vastus3 = 0;

	for (int i = 0; i < 5; i++) {
		vastus1 += liida(0, n);
	}
	cout << setprecision(30) << vastus1 << endl;

	for (int i = 0; i < 5; i++) {
		vastus2 += liidaKiirem(0, n);
	}
	cout << setprecision(30) << vastus2 << endl;
	for (int i = 0; i < 5; i++) {
		for (int j = 0; j < n; j++)
		{
			vastus3 += liidetavad[j];
		}
	}
	cout << setprecision(30) << vastus3 << endl;
	return 0;
}