import java.util.Scanner;

public class Lipud1 {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        // alustame esimeselt realt, kust kutsutakse
        // rekursiivselt vlja jrgmiste ridade proovimisi
        int res = tryrow(0, n);
        System.out.println(res);
    }

    static int MAXN = 16;
    static boolean[][] board = new boolean[MAXN][MAXN];
    static boolean underfire = false;

    static boolean ischecked(int x1, int y1, int x2, int y2) {
        // kaks lippu tulistavad ksteist, kui nad on samal real, veerul vi diagonaalil
        return x1 == x2 || y1 == y2 || x2 - x1 == y2 - y1 || x2 - x1 == y1 - y2;
    }
    static int tryrow(int y, int n) { // y = mitmendale reale proovime lippu panna
        int res = 0;
        for (int x = 0; x < n; x++) { // proovime kiki veerge
            underfire = false;
            for (int y1 = 0; y1 < y; y1++) { // kas eelnevatel ridadel oli mni lipp
                if (underfire) break;
                for (int x1 = 0; x1 < n; x1++) { // mis praegust tulistab
                    if (board[x1][y1] && ischecked(x, y, x1, y1)) {// ei sobi
                        underfire = true;
                        break;
                    }
                }
            }
            if (underfire) continue;
            if (y == n - 1) // oleme viimasel real, liidame vastusele 1
                res++;
            else {
                board[x][y] = true; // mrgime ruudu kasutatuks
                res += tryrow(y + 1, n); // liidame kik jrgmiste ridade vimalused
                // tagurdusmeetodi vtmekoht - proovides jrgmist varianti,
                // tuleb taastada eelnev seis!
                board[x][y] = false;
            }
        }
        return res;
    }
}
