#include <iostream>
using namespace std;

#define MAXN 16
int queens[MAXN]; bool ischecked(int x1, int y1, int x2, int y2) {
	// kaks lippu tulistavad ksteist, kui nad on samal real, veerul vi diagonaalil
	return x1 == x2 || y1 == y2 || x2 - x1 == y2 - y1 || x2 - x1 == y1 - y2;
}

int tryrow(int y, int n) { // y = mitmendale reale proovime lippu panna
	int res = 0;
	for (int x = 0; x < n; x++)	{ // proovime kiki veerge
		for (int y1 = 0; y1 < y; y1++) { // kontrollime kiki eelnevaid lippe
			if (ischecked(x, y, queens[y1], y1)) goto cont; // ei sobi
		}

		if (y == n - 1)
			res++; // oleme viimasel real, liidame vastusele 1
		else {
			queens[y] = x; // jtame uue lipu asukoha meelde
			res += tryrow(y + 1, n); // liidame jrgmiste ridade vimalused
		}
	cont:;
	}
	return res;
}

int main()
{
	int n;
	cin >> n;
	// alustame esimeselt realt, kust kutsutakse 
	// rekursiivselt vlja jrgmiste ridade proovimisi
	int res = tryrow(0, n);
	cout << res;
}

