#include <iostream>
using namespace std;

#define MAXN 16
// peame meeles, millistel veergudel ja diagonaalidel lipud on
char col[MAXN]; // (i, j) -> j
char updiag[2 * MAXN]; // (i, j) -> i + j
char downdiag[2 * MAXN]; // (i, j) -> i - j + N

int tryrow(int y, int n) {// y = mitmendale reale proovime lippu panna
	if (y == n) return 1;

	int res = 0;
	for (int x = 0; x < n; x++) { // proovime kiki veerge
		// kontrollime, kas veerg + diagonaalid on vabad
		if (!col[x] && !updiag[y + x] && !downdiag[y - x + MAXN]) {
			col[x] = 1; // mrgime veeru kasutatuks
			updiag[y + x] = 1;
			downdiag[y - x + MAXN] = 1;

			res += tryrow(y + 1, n); // liidame kik jrgmiste ridade vimalused

			col[x] = 0;  // taastame eelneva seisu
			updiag[y + x] = 0;
			downdiag[y - x + MAXN] = 0;
		}
	}
	return res;
}

int main()
{
	int n;
	cin >> n;
	// alustame esimeselt realt, kust kutsutakse 
	// rekursiivselt vlja jrgmiste ridade proovimisi
	int res = tryrow(0, n);
	cout << res;
}