#include <iostream>
using namespace std;

#define MAXN 16

// peame meeles, millistel ridadel, veergudel ja diagonaalidel lipud on
char row[MAXN];
char col[MAXN]; // (i, j) -> j
char updiag[2 * MAXN]; // (i, j) -> i + j
char downdiag[2 * MAXN]; // (i, j) -> i - j + N
int tryrow(int y, int lim, int n) { // lim = mitut esimese ruutu proovida
	int res = 0;
	if (y == n)	{
		res++;
		if (row[0] < n / 2) res++; // esimese rea esimese poole loeme topelt
		return res;
	}

	for (int x = 0; x < lim; x++) { // proovime kiki veerge
		// kontrollime, kas veerg+diagonaalid on vabad
		if (!col[x] && !updiag[y + x] && !downdiag[y - x + MAXN]) {
			row[y] = x;

			col[x] = 1; // mrgime veeru kasutatuks
			updiag[y + x] = 1;
			downdiag[y - x + MAXN] = 1;

			res += tryrow(y + 1, n, n); // liidame kik jrgmiste ridade vimalused

			col[x] = 0;
			updiag[y + x] = 0;
			downdiag[y - x + MAXN] = 0;
		}
	}

	return res;
}

int main()
{
	int n;
	cin >> n;
	// alustame esimeselt realt, kust kutsutakse 
	// rekursiivselt vlja jrgmiste ridade proovimisi
	int res = tryrow(0, (n + 1) / 2, n); // esimese rea limiit on poole rea pikkuseni
	cout << res;
}

