import sys

MAXN = 16

# peame meeles, millistel ridadel, veergudel ja diagonaalidel lipud on
row = [0 for x in range(MAXN)]
col = [0 for x in range(MAXN)] # (i, j) -> j
updiag = [0 for x in range(MAXN * 2)] # (i, j) -> i + j
downdiag = [0 for x in range(MAXN * 2)] # (i, j) -> i - j + N

def tryrow(y, lim, n): # lim = mitut esimese ruutu proovida
    res = 0
    if y == n:
        res += 1
        if int(row[0]) < n // 2:
            res += 1 # esimese rea esimese poole loeme topelt
        return res
    for x in range(lim): # proovime kõiki veerge
        # kontrollime, kas veerg+diagonaalid on vabad
        if col[x] == 0 and updiag[y + x] == 0 and downdiag[y - x + MAXN] == 0:
            row[y] = str(x)
            col[x] = 1 # märgime veeru kasutatuks
            updiag[y + x] = 1
            downdiag[y - x + MAXN] = 1
            res += tryrow(y + 1, n, n) # liidame kõik järgmiste ridade võimalused
            col[x] = 0
            updiag[y + x] = 0
            downdiag[y - x + MAXN] = 0
    return res

n = int(sys.stdin.readline())
# alustame esimeselt realt, kust kutsutakse
# rekursiivselt välja järgmiste ridade proovimisi
res = tryrow(0, (n + 1) // 2, n)
print(res)