#include <iostream>
using namespace std;

#define MAXN 16

// peame meeles, millistel ridadel, veergudel ja diagonaalidel lipud on
char row[MAXN];
char col[MAXN]; // (i, j) -> j
char updiag[2 * MAXN]; // (i, j) -> i + j
char downdiag[2 * MAXN]; // (i, j) -> i - j + N
int pr[MAXN + 2]; // eelmine vaba veerg
int nx[MAXN + 2]; // jrgmine vaba veerg

int tryrow(int y, int lim, int n) { // lim = mitut esimese rea ruutu proovida
	int res = 0;
	if (y == n)	{
		res++;
		if (row[0] <= n / 2) res++; // esimese rea esimese poole loeme topelt
		return res;
	}

	for (int x = nx[0]; x <= lim; x = nx[x]) { // proovime ainut vabu veerge
		// kontrollime, kas diagonaalid on vabad
		if (!updiag[y + x] && !downdiag[y - x + MAXN]) {
			row[y] = x;

			col[x] = 1; // mrgime veeru kasutatuks
			updiag[y + x] = 1;
			downdiag[y - x + MAXN] = 1;

			nx[pr[x]] = nx[x]; // eemaldame veeru ahelast 
			pr[nx[x]] = pr[x];

			res += tryrow(y + 1, n, n);

			nx[pr[x]] = x; // taastame veeru ahelasse
			pr[nx[x]] = x;

			col[x] = 0;
			updiag[y + x] = 0;
			downdiag[y - x + MAXN] = 0;
		}
	}

	return res;
}

int main()
{
	int n;
	cin >> n;
	//Initsialiseerime ahela. Alguses on kik veerud vabad ja ahelas
	for (int i = 0; i < MAXN + 2; i++) {
		pr[i] = i-1;
		nx[i] = i+1;
	}
	// alustame esimeselt realt, kust kutsutakse 
	// rekursiivselt vlja jrgmiste ridade proovimisi
	int res = tryrow(0, (n + 1) / 2, n); // esimese rea limiit on poole rea pikkuseni
	cout << res;
}
