import java.util.Scanner;

public class Lipud5 {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        //Initsialiseerime ahela. Alguses on kik veerud vabad ja ahelas
        for (int i = 0; i < MAXN + 2; i++) {
            pr[i] = i-1;
            nx[i] = i+1;
        }
        int res = tryrow(0, (n + 1) / 2, n);
        System.out.println(res);
    }

    static int MAXN = 16;

    // peame meeles, millistel ridadel, veergudel ja diagonaalidel lipud on
    static char[] row = new char[MAXN];
    static char[] col = new char[MAXN]; // (i, j) -> j
    static char[] updiag = new char[2 * MAXN]; // (i, j) -> i + j
    static char[] downdiag = new char[2 * MAXN]; // (i, j) -> i - j + N

    static int[] pr = new int[MAXN + 2]; // eelmine vaba veerg
    static int[] nx = new int[MAXN + 2]; // jrgmine vaba veerg

    static int tryrow(int y, int lim, int n) { // lim = mitut esimese rea ruutu proovida
        int res = 0;
        if (y == n) {
            res++;
            if (row[0] <= n / 2) res++; // esimese rea esimese poole loeme topelt
            return res;
        }
        for (int x = nx[0]; x <= lim; x = nx[x]) { // proovime ainut vabu veerge
            // kontrollime, kas diagonaalid on vabad
            if (updiag[y + x] == 0 && downdiag[y - x + MAXN] == 0) {
                row[y] = (char)x;
                col[x] = 1; // mrgime veeru kasutatuks
                updiag[y + x] = 1;
                downdiag[y - x + MAXN] = 1;
                nx[pr[x]] = nx[x]; // eemaldame veeru ahelast
                pr[nx[x]] = pr[x];
                res += tryrow(y + 1, n, n);
                nx[pr[x]] = x; // taastame veeru ahelasse
                pr[nx[x]] = x;
                col[x] = 0;
                updiag[y + x] = 0;
                downdiag[y - x + MAXN] = 0;
            }
        }
        return res;
    }
}
