import java.util.Scanner;

public class Lipud7 {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        // alustame esimeselt realt, kust kutsutakse
        // rekursiivselt vlja jrgmiste ridade proovimisi
        int res = nqueens(n);
        System.out.println(res);
    }

    static int MAXN = 16;

    static int nqueens(int n) {
        int[] col = new int[MAXN]; // parameetrite massiivid
        int[] updiag = new int[MAXN];
        int[] downdiag = new int[MAXN];
        int[] positions = new int[MAXN];
        int half = (n + 1) / 2;
        int halfwayBit = n % 2 == 1 ? 1 << half - 1: -1;
        int res = 0;
        int fullMask = (1 << n) - 1;
        int halfMask = (1 << half) - 1;
        int y = 0;
        positions[0] = halfMask;
        col[0] = updiag[0] = downdiag[0] = 0;
        int points = 2;
        int bits = positions[0];
        for (;;)
        {
            if (bits == 0) { // praegusel real vimalused otsas
                if (y == 0) break; // esimene rida lbi
                bits = positions[--y]; // tagasi eelmisele reale
            }
            else
            {
                int lsb = lsb = -(bits) & bits; // alumine vaba bitt
                if (y == 0 && lsb == halfwayBit) {
                    points = 1;
                }
                bits &= ~lsb; // nullime praeguse ruudu
                if (y < n - 1) { // saab minna jrgmisele reale
                    positions[y] = bits; // salvestame eelmise positsiooni
                    int prev = y++;
                    updiag[y] = (updiag[prev] | lsb) >> 1; // jrgmise rea diagonaal
                    downdiag[y] = (downdiag[prev] | lsb) << 1; // jrgmise rea diagonaal
                    col[y] = col[prev] | lsb; // jrgmise rea hivatud veerud
                    bits = fullMask & ~(col[y] | updiag[y] | downdiag[y]); // vabad bitid
                    positions[y] = bits;
                }
                else
                    res += points; // viimane rida, suurendame skoori
            }
        }
        return res;
    }
}
