#include <iostream>
#include <stack>
#include <queue>
using namespace std;

int main() {
    int peatuste_arv, kohtade_arv, jk_pikkus;

    stack<int> tramm; //pinu trammis olevate reisijate hoidmiseks, kes viimasena sisenes, vljub esimesena
    queue<int> trammisabad[100]; //Massiiv trammisabadest. Iga trammisaba on jrjekord, kes enne sabas, lheb enne peale
    
    cin >> peatuste_arv >> kohtade_arv >> jk_pikkus;

    for (int i = 0; i < peatuste_arv; i++) { // iga peatuse kohta
        int ootajate_arv; 
        cin >> ootajate_arv; // loeme ootajate arvu peatuses
        for (int j = 0; j < ootajate_arv; j++) { // ja iga ootaja kohta
            int sihtkoht;
            cin >> sihtkoht; // loeme tema sihtkoha
            trammisabad[i].push(sihtkoht - 1); // ning paneme selles peatuses sabasse ootele
        }
    }

    int peatus = 0, kulunud_aeg = 0; // alustame esimesest peatusest
    while (true) {
        // mahalaadimine
        while (!tramm.empty() && // kuni trammis on reisijaid ja 
            ((trammisabad[peatus].size() < jk_pikkus) || // peatuses on ruumi vi
                tramm.top() == peatus)) { // on jrgmine mahamineja judnud oma peatusesse
            if (tramm.top() != peatus) { // kui jrgmine vljuja ei ole oma peatuses
                trammisabad[peatus].push(tramm.top()); // lheb ta selle peatuse sabasse
            }
            tramm.pop(); // eemaldame vljuja trammist
            kulunud_aeg++; // lisame vljumiseks kulunud aja
        }

        bool valmis = tramm.empty(); // kas tramm on thi?
        for (int i = 0; i < peatuste_arv; i++) {
            valmis &= trammisabad[i].empty(); // kas kik peatuste sabad on thjad?
        }
        if (valmis)
            break; // kik reisijad on kohal

        kulunud_aeg += 5; // liidame peatuses sitmiseks kulunud aja

        // pealelaadimine
        while ((tramm.size() < kohtade_arv) && // kuni trammis on ruumi
                !trammisabad[peatus].empty()) { // ja peatuses on ootajaid
            tramm.push(trammisabad[peatus].front()); // paneme trammi peatusest esimese ootaja
            trammisabad[peatus].pop(); // ja eemaldame ta trammisabast
            kulunud_aeg++; // lisame sisenemiseks kulunud aja
        }

        peatus = (peatus + 1) % peatuste_arv; // jrgmine peatus
        kulunud_aeg += 60; // liidame peatuste vahel sitmiseks kulunud aja
    }

    cout << kulunud_aeg << endl;

    return 0;
}
