from collections import deque
import sys

s = sys.stdin.readline()
strs = s.split()
peatuste_arv = int(strs[0])
kohtade_arv = int(strs[1])
jk_pikkus = int(strs[2])
tramm = [] #pinu trammis olevate reisijate hoidmiseks
trammisabad = [] #Massiiv trammisabadest peatustes

for i in range(100):
    trammisabad.append(deque([]))
for i in range(peatuste_arv): # iga peatuse kohta
    s = sys.stdin.readline()
    strs = s.split()
    ootajate_arv = int(strs[0]) # loeme ootajate arvu peatuses
    for j in range(ootajate_arv): # ja iga ootaja kohta
        sihtkoht = int(strs[j + 1]) # loeme tema sihtkoha
        # ning paneme selles peatuses sabasse ootele
        trammisabad[i].append(sihtkoht - 1)

peatus = 0
kulunud_aeg = 0 # alustame esimesest peatusest
while (True):
    # mahalaadimine
    while (tramm and # kuni trammis on reisijaid ja
            ((len(trammisabad[peatus]) < jk_pikkus) or # peatuses on ruumi või
            tramm[-1] == peatus)): # on järgmine väljuja jõudnud sihtkohta
        if (tramm[-1] != peatus): # kui järgmine väljuja ei ole sihtkohas
            # läheb ta selle peatuse sabasse
            trammisabad[peatus].append(tramm[-1])
        tramm.pop() # eemaldame väljuja trammist
        kulunud_aeg += 1 # lisame väljumiseks kulunud aja

    valmis = not tramm # kas tramm on tühi?
    for i in range(peatuste_arv):
        valmis &= not trammisabad[i] # ja kõik peatuste sabad on tühjad?
    if (valmis):
        break # siis kõik reisijad on kohal, lõpetame

    kulunud_aeg += 5 # liidame peatuses sõitmiseks kulunud aja

    # pealelaadimine
    while ((len(tramm) < kohtade_arv) and # kuni trammis on ruumi
            trammisabad[peatus]): # ja peatuses on ootajaid
        # paneme trammi peatusest esimese ootaja ja eemaldame ta trammisabast
        tramm.append(trammisabad[peatus].popleft())
        kulunud_aeg += 1 # lisame sisenemiseks kulunud aja

    peatus = (peatus + 1) % peatuste_arv # järgmine peatus
    kulunud_aeg += 60 # liidame peatuste vahel sõitmiseks kulunud aja

print(kulunud_aeg) #väljastame kulunud aja
