
EPS = 1e-20
min_jaak = 0
max_jaak = 0
vaartus = float(input())
alus = float(input())
vastus = ""

#leiab leitavast kohast ülejääva osa lubatava maksimaalse ja minimaalse väärtuse
def leiaJaagid(astendatudalus, min_kordaja, max_kordaja):
    global min_jaak, max_jaak
    if not (astendatudalus < 0):
        min_jaak = astendatudalus*min_kordaja - EPS
        max_jaak = astendatudalus*max_kordaja + EPS

    else: # negatiivsel alusel kui on paarituarvuline aste, siis max ja min on vahetuses
        min_jaak = astendatudalus*max_kordaja - EPS
        max_jaak = astendatudalus*min_kordaja + EPS

#Leiab "järgmise" numbri ehk esimese numbri järelejäänud teisendatavast osast
def leiaNumber(astendatudalus, numbrite_arv, min_kordaja, max_kordaja):
    global vaartus
    global min_jaak
    global max_jaak
    kontroll = vaartus
    leiaJaagid(astendatudalus, min_kordaja, max_kordaja)

    # proovime, milline saaks olla järgmine leitav number
    for number in range(0, numbrite_arv):
        if (kontroll > min_jaak) and (kontroll < max_jaak):
            vaartus = kontroll # väärtus saab võrdseks teisendamata osaga
            return str(ord('0') + number)
        # eelmine number ei sobinud, suurema numbri proovimisel vähendame jääki
        kontroll = kontroll - astendatudalus
    return '-'

#keerab stringi ümber ja nihutab koma õigesse kohta
def keera():
    global vastus
    if vastus.find('.') == -1:  # ja tulemuses koma ei ole
        vastus = vastus + ".0" # lisame ".0" vastuse lõppu

    koma_asukoht = vastus.find('.')
    # nihutame koma stringis vasakule, sest see kuulub selle arvu juurde, mille järel ta on nt 123. on tegelikult 1 2 ja 3., keerates tahame saada 3.21
    tmp = vastus[:koma_asukoht - 1] + vastus[koma_asukoht] + vastus[koma_asukoht-1] + vastus[koma_asukoht + 1:]
    vastus = tmp[::-1] # ja keerame vastuse ümber

# eemaldab nullid arvu eest ja lõpust, vajadusel eemaldab ka koma lõpust.
def normaliseeri():
    global vastus
    vastus = vastus.strip('0') # eemaldame nullid murdosa lõpust ja algusest

    if vastus[-1] == '.': # eemaldame koma (täis)arvu lõpust
        vastus = vastus[:-1]

    # kui midagi järele ei jäänud, on vastus 0
    if len(vastus) == 0:
        vastus = "0"

def teisenda(alus):
    vastus = ""
    numbrite_arv = 0 #süsteemis kasutatavate numbrite ehk märkide arv
    astendatudalus = 1.0 #aluse aste, mida töötleme
    p_alus = 1.0 / alus # aluse pöördväärtus
    alus_vahetatud = False
    if abs(p_alus) > abs(alus):
        p_alus = alus
        alus = 1.0 / alus
        alus_vahetatud = True

    while numbrite_arv < abs(alus) - EPS:
        numbrite_arv += 1 # suurendame, kuni on vähemalt aluse absoluutväätusega võrdne

    ennekoma = 0 # kohtade arv enne koma uues süsteemis
    while not (vaartus < astendatudalus):
        astendatudalus *= alus
        ennekoma += 1

    min_kordaja = 0.0
    max_kordaja = 0.0
    if p_alus > 0.0: # kui alus on positiivne
        max_kordaja = float(numbrite_arv - 1) / (alus - 1)
    else:
        min_kordaja = float(numbrite_arv - 1)*p_alus / (1.0 - p_alus*p_alus)
        max_kordaja = min_kordaja / alus

    while (len(vastus) < 990) and (abs(vaartus) > EPS*10.0):
        vastus += leiaNumber(astendatudalus, numbrite_arv, min_kordaja, max_kordaja)
        astendatudalus /= alus
        if ennekoma == 0:
            vastus += '.'
        ennekoma -= 1

    if alus_vahetatud:  # kui alus oli 0 ja 1 vahel
        keera()
    normaliseeri()

    return vastus

print(teisenda(alus))