/* ST ja VK */
#include <iostream>
using namespace std;

// Vahetu Eukleidese algoritm kahe arvu suurima hsiteguri leidmiseks
int syt(int a, int b) {
    while (a != b) {
        if (a > b) {
            a -= b;
        }
        else {
            b -= a;
        }
    }
    return a;
}

// Lhike algoritm kahe arvu suurima hsiteguri leidmiseks
int syt2(int a, int b) {
    return (b == 0) ? a : syt(b, a % b);
}

// Kahe arvu vhima hiskordse leidmine
int vyk(int a, int b) {
    int temp = syt2(a, b);
    return temp ? (a / temp * b) : 0;
}

// Laiendatud Eukleidese algoritm diofantiliste vrrandite lahendamiseks
int dsyt(int a, int b, int &x, int &y) {
    if (b == 0) {
        x = 1;
        y = 0;
        return a;
    }
    int x1, y1, syt = dsyt(b, a % b, x1, y1);
    x = y1;
    y = x1 - (a / b) * y1;
    return syt;
}

int main()
{    
    //ST ja VK
    int a=1, b=0;
    cout << syt(40, 24) << endl;
    cout << syt2(40, 24) << endl;
    cout << vyk(40, 24) << endl;
    int d = dsyt(40, 21, a, b);
    cout << d << " " << a << " " << b << endl;

    return 0;
}