/*Hammasrattad*/
#include <iostream>
#include <set>
using namespace std;

int syt(int a, int b) {
    while (b > 0) {
        int c = b;
        b = a % b;
        a = c;
    }
    return a;
}

int main()
{
    int m, n;
    cin >> m >> n;

    std::set<pair<int, int>> s;
    for (int a = m; a <= n; a++) { // esimese hammasratta vimalikud hambad
        for (int b = m; b <= n; b++) { // teise hammastatta vimalikud hambad
            int d = syt(a, b); // leiame a ja b suurima histeguri
            pair<int, int> p = make_pair(a / d, b / d); // ja jagame a ja b sellega, et leida lekannet
            s.insert(p); // lisame leitud lekande set'i
        }
    }
    cout << s.size(); // vljastame leitud lekannete arvu
    return 0;
}