#include <iostream>
#include <algorithm>

using namespace std;

int leiaYhised(int* jada1, int* jada2, int p1, int p2)
{
    int** yhised = new int*[p1 + 1];
    for (int i = 0; i <= p1; i++) {
        yhised[i] = new int[p2 + 1];
    }
    for (int i = 0; i <= p1; i++) {
        yhised[i][0] = 0;
    }
    for (int j = 0; j <= p2; j++) {
        yhised[0][j] = 0;
    }
    for (int i = 1; i <= p1; i++) {
        for (int j = 1; j <= p2; j++) {
            if (jada1[i - 1] == jada2[j - 1]){
                yhised[i][j] = yhised[i - 1][j - 1] + 1;
            }
            else {
                yhised[i][j] = max((yhised[i - 1][j]), (yhised[i][j - 1]));
            }
        }
    }
    return yhised[p1][p2];
}

int main()
{
    int m, n;
    cin >> m; //esimese jada pikkus
    int* jada1 = new int[m];
    for (int i = 0; i < m; i++) {
        cin >> jada1[i]; // esimese jada elemendid
    }
    cin >> n; //teise jada pikkus
    int* jada2 = new int[n];
    for (int i = 0; i < n; i++) {
        cin >> jada2[i]; //teise jada elemendid
    }

    cout << leiaYhised(jada1, jada2, m, n) << endl;
    return 0;
}
