N = int(input()) #sallide arv
pikkused = []
moevaartused = []
for i in range(N):
    pikkused.append(int(input())) #salli pikkus
    moevaartused.append(int(input()))  # salli moeväärtus

def leiaFeim(N, moevaartused, pikkused):
    # võimalike kombinatsioonide arv, millised sallid võivad söödud olla = 2^n
    kombinatsioonid = 1 << N
    kogupikkus = 0
    for i in range(N):
        kogupikkus += pikkused[i]
    # Siin massiivis hoiame parimaid võimalikke tulemusi, mida on võimalik saavutada,
    # kui meil on alles mingi konkreetne kombinatsioon salle.
    # Massiivi indeksid vastavad sallikombinatsioonide kahendarvulistele väärtustele.
    # Näiteks feimid[37] sisaldab maksimaalset võimalikku väärtust, mida Märdil on
    # võimalik saavutada juhul, kui alles on 1, 3 ja 6 sall (sest 10-süsteemis 37 on
    # kahendsüsteemis 00100101, seatud on altpoolt lugedes 1, 3 ja 6 bitt)
    feimid = [0 for x in range(kombinatsioonid)]
    feimid[0] = 0
    # konstrueerime kõik kombinatsioonid alates lihtsamatest
    for i in range(1, kombinatsioonid):
        feimid[i] = 0

        # Proovime uue kombinatsiooni üles ehitada väiksematest.
        # mvalik on Märdi tehtav valik, st mitmenda salli ta võtab.
        # Proovime kõiki Märdi valikuid

        mbit = 1
        mvalik = 0
        while mbit <= i:
            # bitt pole seatud, st vaadeldav kombinatsioon ei sisalda seda salli
            if (mbit & i) == 0:
                mbit *= 2
                mvalik += 1
                continue
            alles = 1  # tõenäosus, et ühtki head salli ei sööda ära
            feim = moevaartused[mvalik] # Märdi käigu väärtus
            # kvalik on Kärdi tehtav valik, st mitmendale sallile ta augu sööb
            kbit = 1
            kvalik = -1
            while kbit <= i:
                kvalik += 1
                if ((i & kbit) == 0 or mvalik == kvalik):
                    kbit *= 2
                    continue
                prob = pikkused[kvalik] / kogupikkus
                # väärtusele lisandub selle allesjääva kombinatsiooni väärtus, kust
                #on eemaldatud Märdi ja Kärdi sall
                feim += prob * feimid[i ^ mbit ^ kbit]
                alles -= prob
                kbit *= 2
            # Kui Kärt ei söönud ühtki head salli ära, lisandub selle kombinatsiooni
            # väärtus, kus on kõik sallid peale Märdi praeguse valiku
            feim += alles * (feimid[i ^ mbit])
            if feim > feimid[i]:
                feimid[i] = feim
            mbit *= 2
            mvalik += 1
    return feimid[kombinatsioonid - 1]

print(leiaFeim(N, moevaartused, pikkused))