#include <vector>
#include <queue>
#include <iostream>
#include <sstream>
#include <string>
using namespace std;

const int MAX_TIPPE = 100;
vector<int> graaf[MAX_TIPPE];
bool kaidud[MAX_TIPPE] = { 0 }; // alguses kik tipud on kimata
int tippude_arv;

void loegraaf() {
    cin >> tippude_arv;
    string s;
    while (getline(cin, s)){
        istringstream ss(s);
        int tipp, naaber;
        ss >> tipp;
        while (ss >> naaber){
            graaf[tipp - 1].push_back(naaber - 1);
        }
    }
}

void tootle(int tipp)
{
    cout << tipp + 1<< " ";
}

int main()
{
    loegraaf();
    queue<int> jarjekord;
    jarjekord.push(0); // lisame esimese tipu jrjekorda
    kaidud[0] = true; // see tipp on juba jrjekorras olemas

    while (!jarjekord.empty()) {
        int tipp = jarjekord.front();
        jarjekord.pop();
        tootle(tipp);
        for (int i = 0; i < graaf[tipp].size(); i++) {
            int naaber = graaf[tipp][i]; // iga naabertipu,
            if (!kaidud[naaber]) { // kus ei ole veel kinud,
                jarjekord.push(naaber); // lisame jrjekorda
                kaidud[naaber] = true;
            }
        }
    }
    return 0;
}

