import sys
from collections import deque

graaf = []
kaidud = []  # alguses kõik tipud on käimata
tippude_arv = 0

def loegraaf():
    global tippude_arv, graaf
    
    tippude_arv = int(sys.stdin.readline())
    graaf = [[] for k in range(tippude_arv)]

    for rida in sys.stdin:
        loend = [int(s) for s in rida.split()]
        tipp = loend[0]
        for i in range(1, len(loend)):
            graaf[tipp-1].append(loend[i]-1)

def tootle(tipp):
    print(tipp + 1)

loegraaf()
kaidud = [False]*tippude_arv

jarjekord = deque([])
jarjekord.append(0) # lisame esimese tipu järjekorda
kaidud[0] = True # see tipp on juba järjekorras olemas

while (jarjekord):
    tipp = jarjekord.popleft()
    tootle(tipp)
    for naaber in graaf[tipp]:
        if (not kaidud[naaber]): # kus ei ole veel käinud,
            jarjekord.append(naaber) # lisame järjekorda
            kaidud[naaber] = True
