#include <vector>
#include <iostream>
#include <string>
#include <sstream>
using namespace std;

const int MAX_TIPPE = 1000;
vector<int> graaf[MAX_TIPPE];
bool kaidud[MAX_TIPPE] = { 0 }; // alguses kik tipud on kimata
int tippude_arv;

void loegraaf() {
    cin >> tippude_arv;
    string s;
    while (getline(cin, s)){
        istringstream ss(s);
        int tipp, naaber;
        ss >> tipp;
        while (ss >> naaber){
            graaf[tipp-1].push_back(naaber-1);
       }
    }
}

void tootle(int tipp)
{
    cout << tipp + 1 << " ";
}

void otsi(int tipp)
{
    kaidud[tipp] = true; // siin me oleme
    tootle(tipp); // teeme midagi selle tipuga
    for (int i = 0; i < graaf[tipp].size(); i++) {
        int naaber = graaf[tipp][i]; // iga naabertipuga
        if (kaidud[naaber] == false) // kus ei ole veel kinud
            otsi(naaber); // kordame sama protseduuri
    }
}

bool on_tsykkel(int tipp, int eelmine)
{
    kaidud[tipp] = true; 
    for (int i = 0; i < graaf[tipp].size(); i++) {
        int naaber = graaf[tipp][i]; 
        if (kaidud[naaber] == false) {
            if (on_tsykkel(naaber, tipp)) 
                return true;
        }
        else if (naaber != eelmine)
           return true;
    }
    return false;
}

int main()
{
    loegraaf();
    otsi(0);
    
    //nullime kidud massiivi, et saaksime graafi uuesti lbida
    for (int i = 0; i < tippude_arv; i++)
        kaidud[i] = false;
    
    if (on_tsykkel(0, -1))
        cout << "Tskkel leitud.";
    else
        cout << "Tskkel puudub.";
    return 0;
}

