#include <iostream>
#include <queue>
#include <vector>
#include <algorithm>

using namespace std;
#define INF INT_MAX // Lpmatus

const int tippude_arv = 10001; // Suurim vimalik tippude arv.
vector<pair<int, int> > Naabrid[tippude_arv];
int Min_kaugused[tippude_arv]; // Siin hoiame vhimat leitud kaugust algtipust tippu i.
bool Vaadatud[tippude_arv] = { 0 }; // Siin hoiame infot, kas tipp on juba tdeldud

int leia_teepikkus(int start, int siht, int n)
{
    for (int i = 0; i < tippude_arv; i++) 
        Min_kaugused[i] = INF; // alguses oletame, et kik tipud on lpmata kaugel
    // loome oma komparaatori
    class greater { public: bool operator ()(pair<int, int>&p1, pair<int, int>&p2)
        { return p1.second>p2.second; } };
    priority_queue<pair<int, int>, vector<pair< int, int >>, greater > kaugused;
    // Lhtekoha kaugus iseendast on 0
    kaugused.push(make_pair(start, Min_kaugused[start] = 0)); 
    while (!kaugused.empty())
    {
        pair<int, int> lahim_tipp = kaugused.top();
        kaugused.pop();
        int tipp = lahim_tipp.first, vahim_kaugus = lahim_tipp.second;
        if(tipp == siht) { // otsitud tee on leitud
            return vahim_kaugus; //tagastame tee pikkuse
        }
        if (Vaadatud[tipp]) // tipp vaadatud, vtame jrgmise
            continue;
        Vaadatud[tipp] = true; // Siin me oleme
        for (int i = 0; i < Naabrid[tipp].size(); i++) // Iga naabri jaoks
            if (!Vaadatud[Naabrid[tipp][i].first] && // kui naaber on veel kimata 
                Naabrid[tipp][i].second + vahim_kaugus <
                Min_kaugused[Naabrid[tipp][i].first]) 
                kaugused.push(make_pair(Naabrid[tipp][i].first,
                 (Min_kaugused[Naabrid[tipp][i].first] = 
                     Naabrid[tipp][i].second + vahim_kaugus))); 
    }
    return -1; //ei leidnud teed
}

int main()
{
    int n, m, a, b, x, y, t;
    cin >> n >> m >> a >> b;

    for (int i = 0; i < m; i++) { // Koostame graafi
        cin >> x >> y >> t;
        Naabrid[x].push_back(make_pair(y, t));
        Naabrid[y].push_back(make_pair(x, t));
    }
    
    std::cout << leia_teepikkus(a, b, n);
    return 0;
}