import java.util.ArrayList;
import java.util.PriorityQueue;
import java.util.Scanner;

public class Soiduaeg {

    static int tippude_arv = 10001; // Suurim vimalik tippude arv.
    static ArrayList<int[]>[] Naabrid = new ArrayList[tippude_arv];
    static int[] Min_kaugused = new int[tippude_arv];// Siin hoiame vhimat leitud kaugust algtipust tippu i.
    static boolean[] Vaadatud = new boolean[tippude_arv]; // Siin hoiame infot, kas tipp on juba tdeldud

    static int leia_teepikkus(int start, int siht, int n)
    {
        for (int i = 0; i < tippude_arv; i++)
            Min_kaugused[i] = 2000000000; // alguses oletame, et kik tipud on lpmata kaugel
        class greater { public boolean operator (int[] p1, int[] p2)
            { return p1[1]>p2[1]; } };
        PriorityQueue<int[], ArrayList<int[]>, greater > kaugused = new PriorityQueue<>();
        // Lhtekoha kaugus iseendast on 0
        int[] mp = {start, Min_kaugused[start] = 0};
        kaugused.add(mp);
        while (!kaugused.isEmpty())
        {
            int[] lahim_tipp = kaugused.remove();
            int tipp = lahim_tipp[0], vahim_kaugus = lahim_tipp[1];
            if(tipp == siht) { // otsitud tee on leitud
                return vahim_kaugus; //tagastame tee pikkuse
            }
            if (Vaadatud[tipp]) // tipp vaadatud, vtame jrgmise
                continue;
            Vaadatud[tipp] = true; // Siin me oleme
            for (int i = 0; i < Naabrid[tipp].size(); i++) { // Iga naabri jaoks
                if (!Vaadatud[Naabrid[tipp].get(i)[0]] && // kui naaber on veel kimata
                        Naabrid[tipp].get(i)[1] + vahim_kaugus <
                                Min_kaugused[Naabrid[tipp].get(i)[0]])
                    Min_kaugused[Naabrid[tipp].get(i)[0]] = Naabrid[tipp].get(i)[1] + vahim_kaugus;
                    int[] pm = {Naabrid[tipp].get(i)[0], Min_kaugused[Naabrid[tipp].get(i)[0]]};
                    kaugused.add(pm);
            }
        }
        return -1; //ei leidnud teed
    }


    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n, m, a, b, x, y, t;
        n = scanner.nextInt();
        m = scanner.nextInt();
        a = scanner.nextInt();
        b = scanner.nextInt();

        for (int i = 0; i < m; i++) { // Koostame graafi
            x = scanner.nextInt();
            y = scanner.nextInt();
            t = scanner.nextInt();
            int[] yt = {y, t};
            int[] xt = {x, t};
            Naabrid[x].add(yt);
            Naabrid[y].add(xt);
        }

        System.out.println(leia_teepikkus(a, b, n));

    }
}
