import sys
import math

def kaugus(a, b):
    return abs(a-b)

def DTW(n, m, s, t):
    dp = [[math.inf] * (m+1) for i in range(n+1)]
    dp[0][0] = 0

    for i in range(1, n+1):
        for j in range(1, m+1):
            dp[i][j] = min(dp[i - 1][j], dp[i][j - 1], dp[i - 1][j - 1]) + kaugus(s[i - 1], t[j - 1])
    return dp[n][m]

n = int(input())
s=[int(x) for x in input().split()]
m = int(input())
t=[int(x) for x in input().split()]
print(DTW(n,m,s,t))
