import java.util.Scanner;
import java.util.ArrayList;

public class Kaupmees {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int[][] tabel = new int[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (i == j) {
                    tabel[i][j] = 0;
                }
                else if (i < j) {
                   tabel[i][j] = scanner.nextInt();
                }
                else {
                    tabel[i][j] = tabel[j][i];
                }
            }
        }

        ArrayList<Integer> vastus = kaupmees(n, 0, tabel);
    }

    static ArrayList<Integer> kaupmees(int n, int ap, int[][] tabel)
    {
        int[][] dp;
        int n2 = 1 << n;
        dp = new int[n2][n];
        for (int i = 0; i < n2; i++) {
            for (int j = 0; j < n; j++) {
                dp[i][j] = -1;
            }
        }
        for (int i = 0; i < n2; i++) {
            if ((1 << ap & i) > 0) {
                continue;
            }
            if (i == 0) {
                continue;
            }
            ArrayList<Integer> cv = new ArrayList<>();
            for (int j = 0; j < n; j++) {
                int linn = 1 << j;
                if ((i & linn) > 0) {
                    cv.add(j);
                }
            }
            if (cv.size() == 1) {
                dp[i][cv.get(0)] = tabel[ap][cv.get(0)];
                continue;
            }
            for (int j = 0; j < cv.size(); j++) {
                int J = cv.get(j);
                dp[i][J] = 1000000000;
                int pi = i - (1 << J);
                for (int k = 0; k < cv.size(); k++) {
                    int K = cv.get(k);
                    if (K == J || dp[pi][K] == -1 || tabel[K][J] == -1) {
                        continue;
                    }
                    dp[i][J] = Math.min(dp[i][J], dp[pi][K] + tabel[K][J]);
                }
            }
        }
        n2--;
        n2 -= (1 << ap);
        int vas = 1000000000;
        for (int i = 0; i < n; i++) {
            if (tabel[i][ap] == -1) {
                continue;
            }
            vas = Math.min(vas, tabel[i][ap] + dp[n2][i]);
        }
        ArrayList<Integer> vasvec = new ArrayList<>();
        vasvec.add(ap);
        int rd = vas;
        int ni = ap;
        while (n2 != 0) {
            for (int i = 0; i < n; i++) {
                if (dp[n2][i] == -1 || tabel[i][ni] == -1) {
                    continue;
                }
                if (dp[n2][i] + tabel[i][ni] == rd) {
                    rd -= tabel[i][ni];
                    vasvec.add(i);
                    ni = i;
                    n2 -= (1 << i);
                    break;
                }
            }
        }
        return vasvec;
    }
}
