import java.util.Scanner;

public class Kohver {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int kaal = scanner.nextInt();
        int arv = scanner.nextInt();

        int[] kaalud = new int[arv];
        int[] hinnad = new int[arv];
        for (int i = 0; i < arv; i++) {
            kaalud[i] = scanner.nextInt();
            hinnad[i] = scanner.nextInt();
        }

        System.out.println(pakiKott(kaal, arv, kaalud, hinnad));
    }

    static int pakiKott(int maksKaal, int kogus, int kaalud[], int vaartused[])
    {
        int[][] parimad = new int[maksKaal + 1][kogus];

        for (int i = 0; i <= maksKaal; i++) {
            if (kaalud[0] <= i) {
                parimad[i][0] = Math.max(parimad[i][0], vaartused[0]);
            }
        }

        int vastus = 0;
        for (int i = 1; i <= maksKaal; i++) {
            for (int j = 1; j < kogus; j++) {
                parimad[i][j] = parimad[i][j - 1];
                if (kaalud[j] <= i) {
                    parimad[i][j] =
                            Math.max(parimad[i][j], parimad[i - kaalud[j]][j - 1] + vaartused[j]);
                }
                vastus = Math.max(vastus, parimad[i][j]);
            }
        }
        return vastus;
    }
}
