def LevenshteinDistance(n, m, s, t):
    dp = [[0 for x in range(m + 1)] for y in range(n + 1)]
    for i in range(n + 1):
        dp[i][0] = i
    for i in range(m + 1):
        dp[0][i] = i

    for i in range(1, n + 1):
        for j in range(1, m + 1):
            sc = 1
            if s[i-1] == t[j-1]:
                sc = 0
            dp[i][j] = min(min(dp[i - 1][j] + 1, dp[i][j - 1] + 1), dp[i - 1][j - 1] + sc)

    return dp[n][m]

a = input().split(" ")
n = int(a[0])
m = int(a[1])
s = input()
t = input()
vastus = LevenshteinDistance(n, m, s, t)
print(vastus)