import math

def matMul(n, ml):
    dp = [[0 for x in range(n+1)] for y in range(n+1)]

    for vh in range(n+1):# vh - vahed
        i = 1
        while i + vh <= n:
            j = i + vh
            dp[i][j] = 0 if (i==j) else math.inf 
            for k in range(i, j):
                dp[i][j] = min(dp[i][j], dp[i][k] + dp[k + 1][j] + (ml[i - 1] * ml[k] * ml[j]))
            i += 1

    return dp[1][n]


n = int(input())
ml = [int(x) for x in input().split()]
print(matMul(n, ml))
